diff -uwr sourceold/scripts/tcw_technology.cpp source/scripts/tcw_technology.cpp
--- sourceold/scripts/tcw_technology.cpp	2011-10-14 22:25:11.492187500 +0800
+++ source/scripts/tcw_technology.cpp	2012-02-02 09:44:43.147460900 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011-2012 MP-Gaming
+	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -133,6 +133,15 @@
 	Hide_Preset_By_Name(0,"TCW_Nod_APC",true);
 	Hide_Preset_By_Name(0,"TCW_Nod_Mammoth_Tank",true);
 
+	//gdi bar steal-able tech:
+	Hide_Preset_By_Name(0,"TCW_GDI_Rifle_Squad",true);
+	Hide_Preset_By_Name(0,"TCW_GDI_Engineer",true);
+	Hide_Preset_By_Name(0,"TCW_GDI_Missile_Squad",true);
+	Hide_Preset_By_Name(0,"TCW_GDI_Grenadier",true);
+	Hide_Preset_By_Name(0,"TCW_GDI_Sniper",true);
+	Hide_Preset_By_Name(0,"TCW_GDI_Zonetrooper",true);
+	Hide_Preset_By_Name(0,"TCW_GDI_Commando",true);
+
 	//nod wf steal-able tech:
 	Hide_Preset_By_Name(1,"TCW_GDI_Attack_Bike",true);
 	Hide_Preset_By_Name(1,"TCW_GDI_Flame_Tank",true);
@@ -140,6 +149,14 @@
 	Hide_Preset_By_Name(1,"TCW_GDI_Raider_Buggy",true);
 	Hide_Preset_By_Name(1,"TCW_GDI_Scorpion_Tank",true);
 	Hide_Preset_By_Name(1,"TCW_GDI_Stealth_Tank",true);
+
+	//nod hand steal-able tech:
+	Hide_Preset_By_Name(1,"TCW_Nod_Militant_Infantry",true);
+	Hide_Preset_By_Name(1,"TCW_Nod_Saboteur",true);
+	Hide_Preset_By_Name(1,"TCW_Nod_RocketGuy",true);
+	Hide_Preset_By_Name(1,"TCW_Nod_Shadow",true);
+	Hide_Preset_By_Name(1,"TCW_Nod_Black_Hand_Flame",true);
+	Hide_Preset_By_Name(1,"TCW_Nod_Commando",true);
 }
 
 
@@ -149,9 +166,10 @@
 {
 	if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_War_Factory")))
 	{
-		if (Commands->Is_A_Star(enter))
+		if ( (Commands->Is_A_Star(enter)) && (Commands->Get_Player_Type(enter) == 0) )
 		{
-			if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur_Low") == 0) )
+			if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer_Low") == 0) || 
+				(strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur_Low") == 0) )
 			{
 				if (!Get_Vehicle(enter))
 				{
@@ -163,9 +181,10 @@
 }
 void tcw_steal_tech_zone_gwf::Exited(GameObject *obj, GameObject *exit)
 {
-	if (Commands->Is_A_Star(exit))
+	if ( (Commands->Is_A_Star(exit)) && (Commands->Get_Player_Type(exit) == 0) )
 	{
-		if ( (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur_Low") == 0) )
+		if ( (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer_Low") == 0) || 
+			(strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur_Low") == 0) )
 		{
 			Remove_Script(exit,"tcw_i_am_stealing_tech");
 		}
@@ -174,11 +193,12 @@
 
 void tcw_steal_tech_zone_nwf::Entered(GameObject *obj, GameObject *enter)
 {
-	if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_Nod_War_Factory")))
+	if (!Is_Building_Dead(Find_Building_By_Name(0,"TCW_Nod_War_Factory")))
 	{
-		if (Commands->Is_A_Star(enter))
+		if ( (Commands->Is_A_Star(enter)) && (Commands->Get_Player_Type(enter) == 1) )
 		{
-			if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer_Low") == 0) )
+			if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer_Low") == 0) || 
+				(strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur_Low") == 0) )
 			{
 				if (!Get_Vehicle(enter))
 				{
@@ -190,9 +210,68 @@
 }
 void tcw_steal_tech_zone_nwf::Exited(GameObject *obj, GameObject *exit)
 {
-	if (Commands->Is_A_Star(exit))
+	if ( (Commands->Is_A_Star(exit)) && (Commands->Get_Player_Type(exit) == 1) )
+	{
+		if ( (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer_Low") == 0) || 
+			(strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur_Low") == 0) )
+		{
+			Remove_Script(exit,"tcw_i_am_stealing_tech");
+		}
+	}
+}
+
+void tcw_steal_tech_zone_nhon::Entered(GameObject *obj, GameObject *enter)
+{
+	if (!Is_Building_Dead(Find_Building_By_Name(0,"TCW_Hand_Of_Nod")))
+	{
+		if ( (Commands->Is_A_Star(enter)) && (Commands->Get_Player_Type(enter) == 1) )
+		{
+			if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer_Low") == 0) || 
+				(strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur_Low") == 0) )
+			{
+				if (!Get_Vehicle(enter))
+				{
+					Attach_Script_Once(enter,"tcw_i_am_stealing_tech","3");
+				}
+			}
+		}
+	}
+}
+void tcw_steal_tech_zone_nhon::Exited(GameObject *obj, GameObject *exit)
+{
+	if ( (Commands->Is_A_Star(exit)) && (Commands->Get_Player_Type(exit) == 1) )
+	{
+		if ( (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer_Low") == 0) || 
+			(strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur_Low") == 0) )
+		{
+			Remove_Script(exit,"tcw_i_am_stealing_tech");
+		}
+	}
+}
+
+void tcw_steal_tech_zone_gbar::Entered(GameObject *obj, GameObject *enter)
+{
+	if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Barracks")))
+	{
+		if ( (Commands->Is_A_Star(enter)) && (Commands->Get_Player_Type(enter) == 0) )
+		{
+			if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Engineer_Low") == 0) || 
+				(strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Saboteur_Low") == 0) )
+			{
+				if (!Get_Vehicle(enter))
+				{
+					Attach_Script_Once(enter,"tcw_i_am_stealing_tech","4");
+				}
+			}
+		}
+	}
+}
+void tcw_steal_tech_zone_gbar::Exited(GameObject *obj, GameObject *exit)
+{
+	if ( (Commands->Is_A_Star(exit)) && (Commands->Get_Player_Type(exit) == 0) )
 	{
-		if ( (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer_Low") == 0) )
+		if ( (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Engineer_Low") == 0) || 
+			(strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur") == 0) || (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Saboteur_Low") == 0) )
 		{
 			Remove_Script(exit,"tcw_i_am_stealing_tech");
 		}
@@ -220,11 +299,29 @@
 		Send_Message_Team(1,255,204,0,stealermsg);
 		Create_2D_WAV_Sound_Team("building_capture.wav",1);
 	}
+	else if (building == 3)//gdi stealing nod hand of nod
+	{
+		Commands->Start_Timer(obj,this,15.0f,779903);//start stealing from the nod hand of nod
+		char stealermsg[250];
+		sprintf(stealermsg,"%s is stealing technology from the Hand of Nod.",Get_Player_Name(obj));
+		Send_Message_Team(1,255,204,0,stealermsg);
+		Create_2D_WAV_Sound_Team("building_capture.wav",1);
+	}
+	else if (building == 4)//nod stealing gdi barracks
+	{
+		Commands->Start_Timer(obj,this,15.0f,779904);//start stealing from the gdi barracks
+		char stealermsg[250];
+		sprintf(stealermsg,"%s is stealing technology from the GDI Barracks.",Get_Player_Name(obj));
+		Send_Message_Team(0,255,0,0,stealermsg);
+		Create_2D_WAV_Sound_Team("building_capture.wav",0);
+	}
 }
 void tcw_i_am_stealing_tech::Timer_Expired(GameObject *obj, int number)
 {
 	if (number == 779901)//nod stole tech from gdi wf
 	{
+		if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_War_Factory")))
+		{
 		if (Get_Total_Bullets(obj,"TCW_Weapon_Repairgun_Advanced") == 5)//full repairgun = successful stealing
 		{
 			Commands->Select_Weapon(obj,"TCW_Weapon_Pistol");
@@ -248,8 +345,10 @@
 			Destroy_Script();
 		}
 	}
-
-	if (number == 779902)//gdi stole tech from nod wf
+	}
+	else if (number == 779902)//gdi stole tech from nod wf
+	{
+		if (!Is_Building_Dead(Find_Building_By_Name(0,"TCW_Nod_War_Factory")))
 	{
 		if (Get_Total_Bullets(obj,"TCW_Weapon_Repairgun_Advanced") == 5)//full repairgun = successful stealing
 		{
@@ -276,8 +375,70 @@
 		}
 	}
 }
+	else if (number == 779903)//gdi stole tech from nod hand
+	{
+		if (!Is_Building_Dead(Find_Building_By_Name(0,"TCW_Hand_Of_Nod")))
+		{
+			if (Get_Total_Bullets(obj,"TCW_Weapon_Repairgun_Advanced") == 5)//full repairgun = successful stealing
+			{
+				Commands->Select_Weapon(obj,"TCW_Weapon_Pistol");
+				Remove_Weapon(obj,"TCW_Weapon_Repairgun_Advanced");
+					
+				Hide_Preset_By_Name(1,"TCW_Nod_Militant_Infantry",false);
+				Hide_Preset_By_Name(1,"TCW_Nod_Saboteur",false);
+				Hide_Preset_By_Name(1,"TCW_Nod_RocketGuy",false);
+				Hide_Preset_By_Name(1,"TCW_Nod_Shadow",false);
+				Hide_Preset_By_Name(1,"TCW_Nod_Black_Hand_Flame",false);
+				Hide_Preset_By_Name(1,"TCW_Nod_Commando",false);
+
+				char stealmsg[250];
+				sprintf(stealmsg,"%s has stolen technology from the Hand of Nod",Get_Player_Name(obj));
+				Send_Message_Team(1,255,204,0,stealmsg);
+				Send_Message_Team(1,255,204,0,"New technology acquired.");
+				Create_2D_WAV_Sound_Team("gdi_new_tech_acquired.wav",1);
+			}
+			else
+			{
+				Send_Message_Player(obj,255,204,0,"To steal technology you need a FULL AMMO Repair Gun.");
+				Destroy_Script();
+			}
+		}
+	}
+	else if (number == 779904)//nod stole tech from gdi barracks
+	{
+		if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Barracks")))
+		{
+			if (Get_Total_Bullets(obj,"TCW_Weapon_Repairgun_Advanced") == 5)//full repairgun = successful stealing
+			{
+				Commands->Select_Weapon(obj,"TCW_Weapon_Pistol");
+				Remove_Weapon(obj,"TCW_Weapon_Repairgun_Advanced");
+					
+				Hide_Preset_By_Name(0,"TCW_GDI_Rifle_Squad",false);
+				Hide_Preset_By_Name(0,"TCW_GDI_Engineer",false);
+				Hide_Preset_By_Name(0,"TCW_GDI_Missile_Squad",false);
+				Hide_Preset_By_Name(0,"TCW_GDI_Grenadier",false);
+				Hide_Preset_By_Name(0,"TCW_GDI_Sniper",false);
+				Hide_Preset_By_Name(0,"TCW_GDI_Zonetrooper",false);
+				Hide_Preset_By_Name(0,"TCW_GDI_Commando",false);
+
+				char stealmsg[250];
+				sprintf(stealmsg,"%s has stolen technology from the GDI Barracks",Get_Player_Name(obj));
+				Send_Message_Team(0,255,0,0,stealmsg);
+				Send_Message_Team(0,255,0,0,"New technology acquired.");
+				Create_2D_WAV_Sound_Team("nod_new_tech_acquired.wav",0);
+			}
+			else
+			{
+				Send_Message_Player(obj,255,0,0,"To steal technology you need a FULL AMMO Repair Gun.");
+				Destroy_Script();
+			}
+		}
+	}
+}
 
 
+ScriptRegistrant<tcw_steal_tech_zone_gbar> tcw_steal_tech_zone_gbar_Registrant("tcw_steal_tech_zone_gbar","");
+ScriptRegistrant<tcw_steal_tech_zone_nhon> tcw_steal_tech_zone_nhon_Registrant("tcw_steal_tech_zone_nhon","");
 ScriptRegistrant<tcw_steal_tech_zone_nwf> tcw_steal_tech_zone_nwf_Registrant("tcw_steal_tech_zone_nwf","");
 ScriptRegistrant<tcw_steal_tech_zone_gwf> tcw_steal_tech_zone_gwf_Registrant("tcw_steal_tech_zone_gwf","");
 ScriptRegistrant<tcw_i_am_stealing_tech> tcw_i_am_stealing_tech_Registrant("tcw_i_am_stealing_tech","Building=1:int");
diff -uwr sourceold/scripts/tcw_technology.h source/scripts/tcw_technology.h
--- sourceold/scripts/tcw_technology.h	2011-10-14 22:27:32.105468700 +0800
+++ source/scripts/tcw_technology.h	2012-02-02 09:44:43.172851500 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011-2012 MP-Gaming
+	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -40,6 +40,15 @@
 	void Exited(GameObject *obj, GameObject *exit);
 };
 
+class tcw_steal_tech_zone_nhon : public ScriptImpClass {
+	void Entered(GameObject *obj, GameObject *enter);
+	void Exited(GameObject *obj, GameObject *exit);
+};
+
+class tcw_steal_tech_zone_gbar : public ScriptImpClass {
+	void Entered(GameObject *obj, GameObject *enter);
+	void Exited(GameObject *obj, GameObject *exit);
+};
 
 class tcw_i_am_stealing_tech : public ScriptImpClass {
 	void Created(GameObject *obj);
diff -uwr sourceold/scripts/tcw_vehicle.cpp source/scripts/tcw_vehicle.cpp
--- sourceold/scripts/tcw_vehicle.cpp	2011-10-14 22:25:11.452148400 +0800
+++ source/scripts/tcw_vehicle.cpp	2012-02-02 09:44:43.121093700 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011-2012 MP-Gaming
+	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -15,6 +15,7 @@
 #include "scripts.h"
 #include "engine.h"
 #include "tcw_vehicle.h"
+#include "VehicleGameObj.h"
 
 void tcw_vehicle::Created(GameObject *obj)
 {
@@ -450,11 +451,32 @@
 		{
 			Commands->Start_Timer(obj,this,0.5f,100100);
 		}
-		if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Pitbull") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Pitbull") == 0) )
+		else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Pitbull") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Pitbull") == 0)  || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Attack_Bike") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Attack_Bike") == 0) )
 		{
 			Commands->Start_Timer(obj,this,5.0f,1004);
 			triggerstealthdetection = true;
 		}
+		else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_APC") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_APC") == 0) )
+		{
+			if (Get_Vehicle_Occupant(obj,1))//if there is a passenger
+			{
+				if ( (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_GDI_Missile_Squad") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_Nod_RocketGuy") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_Nod_RocketGuy_Low") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_GDI_Missile_Squad_Low") == 0) )
+				{
+					Commands->Give_PowerUp(obj,"TCW_POW_APC_Missile_Weapon",false);
+					Commands->Select_Weapon(obj,"TCW_Weapon_APC_Missile");
+				}
+				else if ( (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_GDI_Sniper") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_GDI_Sniper_Low") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_Nod_Sniper") == 0) )
+				{
+					Commands->Give_PowerUp(obj,"TCW_POW_APC_Sniper_Weapon",false);
+					Commands->Select_Weapon(obj,"TCW_Weapon_APC_Sniper");
+				}
+				else if ( (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_GDI_Zonetrooper") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_GDI_Zonetrooper_Low") == 0) || (strcmp(Commands->Get_Preset_Name(Get_Vehicle_Occupant(obj,1)),"TCW_Nod_Zonetrooper") == 0) )
+				{
+					Commands->Give_PowerUp(obj,"TCW_POW_APC_Zonetrooper_Weapon",false);
+					Commands->Select_Weapon(obj,"TCW_Weapon_APC_Zonetrooper");
+				}
+			}
+		}
 	}
 	else if (message == CUSTOM_EVENT_VEHICLE_EXITED)
 	{
@@ -462,6 +484,21 @@
 		{
 			triggerstealthdetection = false;
 		}
+		else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_GDI_Harvester") == 0) )
+		{
+			Commands->Set_Player_Type(obj,0);
+		}
+		else if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester") == 0)
+		{
+			Commands->Set_Player_Type(obj,1);
+		}
+		else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_APC") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_APC") == 0) )
+		{
+			if (!Get_Vehicle_Occupant(obj,1))//if there is no passenger
+			{
+				Commands->Select_Weapon(obj,"TCW_Weapon_APC");//let's always select the normal weapon when someone exits the vehicle
+			}
+		}
 	}
 	else if (message == 1004)//destealth unit
 	{ 
@@ -509,6 +546,8 @@
 	}
 	else if (number == 1004)
 	{
+		if (Get_Vehicle_Occupant(obj,0))//fix empty pitbull stealthdetection errors
+		{
 		Send_Custom_Event_To_Object(obj,"TCW_Nod_Shadow",1004,1,0);
 		Send_Custom_Event_To_Object(obj,"TCW_Nod_Shadow_Low",1004,1,0);
 		Send_Custom_Event_To_Object(obj,"TCW_Nod_Stealth_Tank",1004,1,0);
@@ -528,6 +567,7 @@
 			}
 		}
 	}
+	}
 	else if (number == 1005)//enable stealth again after distance check 
 	{
 		Commands->Enable_Stealth(obj, true);
@@ -634,27 +674,38 @@
 void tcw_vehexit_killtimer::Created(GameObject *obj)
 {
 	timerid = Commands->Get_ID(obj);
+	driverid = 0;
 }
 void tcw_vehexit_killtimer::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
+	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
+	{
+		driverid = Commands->Get_ID(Get_Vehicle_Driver(obj));
+		//driverid = Commands->Get_ID(sender);
+	}
+	else if (message == CUSTOM_EVENT_VEHICLE_EXITED)
 	{
-		Commands->Start_Timer(obj,this,60.0f,Commands->Get_ID(obj));
+		Commands->Start_Timer(obj,this,30.0f,timerid);
 	}
 }
 void tcw_vehexit_killtimer::Timer_Expired(GameObject *obj, int number)
 {
 	if (number == timerid)
 	{
-		if (!Get_Vehicle_Driver(obj))
+		if (!Commands->Find_Object(driverid))
 		{
 			Commands->Destroy_Object(obj);
 		}
+		else
+		{
+			Commands->Start_Timer(obj,this,30.0f,timerid);
+		}
 	}
 }
 void tcw_vehexit_killtimer::Register_Auto_Save_Variables()
 {
 	Auto_Save_Variable(&timerid,sizeof(timerid),1);
+	Auto_Save_Variable(&driverid,sizeof(driverid),2);
 }
 
 
diff -uwr sourceold/scripts/tcw_vehicle.h source/scripts/tcw_vehicle.h
--- sourceold/scripts/tcw_vehicle.h	2011-10-15 12:39:38.283203100 +0800
+++ source/scripts/tcw_vehicle.h	2012-02-02 09:44:43.187500000 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011-2012 MP-Gaming
+	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -33,4 +33,5 @@
 	void Timer_Expired(GameObject *obj, int number);
 	public: void Register_Auto_Save_Variables();
 	int timerid;
+	int driverid;
 };
diff -uwr sourceold/scripts/tcw_zone.cpp source/scripts/tcw_zone.cpp
--- sourceold/scripts/tcw_zone.cpp	2011-10-14 22:25:11.448242100 +0800
+++ source/scripts/tcw_zone.cpp	2012-02-02 09:44:43.118164000 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011-2012 MP-Gaming
+	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
diff -uwr sourceold/scripts/tcw_zone.h source/scripts/tcw_zone.h
--- sourceold/scripts/tcw_zone.h	2011-10-15 12:39:38.268554600 +0800
+++ source/scripts/tcw_zone.h	2012-02-02 09:44:43.158203100 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011-2012 MP-Gaming
+	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
Only in source/scripts: z_domination.cpp
Only in source/scripts: z_domination.h
diff -uwr sourceold/swap/Swap.cpp source/swap/Swap.cpp
--- sourceold/swap/Swap.cpp	2011-10-13 07:20:03.158203100 +0800
+++ source/swap/Swap.cpp	2012-01-11 22:21:18.041992100 +0800
@@ -14,6 +14,11 @@
 #include "gmgame.h"
 #include "Iterator.h"
 
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 #define GDI 1
 #define NOD 0
 #define GREEN "104,234,40"
@@ -214,7 +219,7 @@
 				Commands->Attach_Script(rtccontroller,"RTC_timer","");
 				const char *str = Get_Team_Name(0);
 				const char *str2 = Get_Team_Name(1);
-				Msg.Format("msg %s on the %s team wants to swap with someone on the %s team. Type \"!rtc\" or \"!swap\" to change with them. There is %i seconds remaining before this expires.", Get_Player_Name(Get_GameObj(PlayerID)), str, str2, swap.SwapExpireLimit);
+				Msg.Format("msg %s on the %s team wants to swap with someone on the %s team. Type \"!rtc\" or \"!swap\" to change with them. There are %i seconds remaining before this expires.", Get_Player_Name(Get_GameObj(PlayerID)), str, str2, swap.SwapExpireLimit);
 				Console_Input(Msg);
 				delete[] str;
 				delete[] str2;
@@ -237,7 +242,7 @@
 				Commands->Attach_Script(rtccontroller,"RTC_timer","");
 				const char *str = Get_Team_Name(0);
 				const char *str2 = Get_Team_Name(1);
-				Msg.Format("msg %s on the %s team wants to swap with someone on the %s team. Type \"!rtc\" or \"!swap\" to change with them. There is 1 minute remaining before this expires.",Get_Player_Name(Get_GameObj(PlayerID)),str,str2);
+				Msg.Format("msg %s on the %s team wants to swap with someone on the %s team. Type \"!rtc\" or \"!swap\" to change with them. There are %i seconds remaining before this expires.",Get_Player_Name(Get_GameObj(PlayerID)),str,str2, swap.SwapExpireLimit);
 				Console_Input(Msg);
 				delete[] str;
 				delete[] str2;
diff -uwr sourceold/teamspeak/teamspeak.cpp source/teamspeak/teamspeak.cpp
--- sourceold/teamspeak/teamspeak.cpp	2011-10-11 23:02:36.131835900 +0800
+++ source/teamspeak/teamspeak.cpp	2012-01-11 22:21:38.350585900 +0800
@@ -13,6 +13,12 @@
 #include "teamspeak.h"
 #include "TCPclass.h"
 #include "gmgame.h"
+
+void* HookupAT3x(void* a, void* b, void* c, void* patch_start, void* patch_end, int (*version_selector)())
+{
+	return HookupAT3(a,b,c,patch_start,patch_end,version_selector);
+}
+
 TCPSocket *Client;
 
 class TS3 : public Plugin
